# autogenerated by genmsg_py from AllowedCollisionMatrix.msg. Do not edit.
import roslib.message
import struct

import planning_environment_msgs.msg

class AllowedCollisionMatrix(roslib.message.Message):
  _md5sum = "c5785d58d2d0b6270738f65222dbec5d"
  _type = "planning_environment_msgs/AllowedCollisionMatrix"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# the list of link names in the matrix
string[] link_names

# the individual entries in the allowed collision matrix
# symmetric, with same order as link_names
AllowedCollisionEntry[] entries

================================================================================
MSG: planning_environment_msgs/AllowedCollisionEntry
# whether or not collision checking is enabled
bool[] enabled

"""
  __slots__ = ['link_names','entries']
  _slot_types = ['string[]','planning_environment_msgs/AllowedCollisionEntry[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   link_names,entries
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(AllowedCollisionMatrix, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.link_names is None:
        self.link_names = []
      if self.entries is None:
        self.entries = []
    else:
      self.link_names = []
      self.entries = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      #serialize self.link_names
      length = len(self.link_names)
      buff.write(struct.pack('<I', length))
      for val1 in self.link_names:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.entries
      length = len(self.entries)
      buff.write(struct.pack('<I', length))
      for val1 in self.entries:
        #serialize val1.enabled
        length = len(val1.enabled)
        buff.write(struct.pack('<I', length))
        pattern = '<%sB'%length
        buff.write(struct.pack(pattern, *val1.enabled))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      #deserialize self.link_names
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.link_names = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.link_names.append(val1)
      #deserialize self.entries
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.entries = []
      for i in xrange(0, length):
        val1 = planning_environment_msgs.msg.AllowedCollisionEntry()
        #deserialize val1.enabled
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sB'%length
        start = end
        end += struct.calcsize(pattern)
        val1.enabled = struct.unpack(pattern, str[start:end])
        val1.enabled = map(bool, val1.enabled)
        self.entries.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      #serialize self.link_names
      length = len(self.link_names)
      buff.write(struct.pack('<I', length))
      for val1 in self.link_names:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.entries
      length = len(self.entries)
      buff.write(struct.pack('<I', length))
      for val1 in self.entries:
        #serialize val1.enabled
        length = len(val1.enabled)
        buff.write(struct.pack('<I', length))
        pattern = '<%sB'%length
        buff.write(val1.enabled.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      #deserialize self.link_names
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.link_names = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.link_names.append(val1)
      #deserialize self.entries
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.entries = []
      for i in xrange(0, length):
        val1 = planning_environment_msgs.msg.AllowedCollisionEntry()
        #deserialize val1.enabled
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sB'%length
        start = end
        end += struct.calcsize(pattern)
        val1.enabled = numpy.frombuffer(str[start:end], dtype=numpy.bool, count=length)
        val1.enabled = map(bool, val1.enabled)
        self.entries.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

