# autogenerated by genmsg_py from SetAllowedCollisionsRequest.msg. Do not edit.
import roslib.message
import struct

import motion_planning_msgs.msg

class SetAllowedCollisionsRequest(roslib.message.Message):
  _md5sum = "65c7c509a65301718d2c95e5eecf2f05"
  _type = "planning_environment_msgs/SetAllowedCollisionsRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """

motion_planning_msgs/OrderedCollisionOperations ord

================================================================================
MSG: motion_planning_msgs/OrderedCollisionOperations
# A set of collision operations that will be performed in the order they are specified
CollisionOperation[] collision_operations
================================================================================
MSG: motion_planning_msgs/CollisionOperation
# A definition of a collision operation
# E.g. ("gripper",COLLISION_SET_ALL,ENABLE) will enable collisions 
# between the gripper and all objects in the collision space

string object1
string object2
string COLLISION_SET_ALL="all"
string COLLISION_SET_OBJECTS="objects"
string COLLISION_SET_ATTACHED_OBJECTS="attached"

# The penetration distance to which collisions are allowed. This is 0.0 by default.
float64 penetration_distance

# Flag that determines whether collisions will be enabled or disabled for the pair of objects specified above
int32 operation
int32 DISABLE=0
int32 ENABLE=1

"""
  __slots__ = ['ord']
  _slot_types = ['motion_planning_msgs/OrderedCollisionOperations']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   ord
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(SetAllowedCollisionsRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.ord is None:
        self.ord = motion_planning_msgs.msg.OrderedCollisionOperations()
    else:
      self.ord = motion_planning_msgs.msg.OrderedCollisionOperations()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      #serialize self.ord.collision_operations
      length = len(self.ord.collision_operations)
      buff.write(struct.pack('<I', length))
      for val1 in self.ord.collision_operations:
        length = len(val1.object1)
        #serialize val1.object1
        buff.write(struct.pack('<I%ss'%length, length, val1.object1))
        length = len(val1.object2)
        #serialize val1.object2
        buff.write(struct.pack('<I%ss'%length, length, val1.object2))
        buff.write(struct.pack('<di', val1.penetration_distance, val1.operation))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.ord is None:
        self.ord = motion_planning_msgs.msg.OrderedCollisionOperations()
      end = 0
      #deserialize self.ord.collision_operations
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.ord.collision_operations = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.CollisionOperation()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.object1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.object1,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.object2
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.object2,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 12
        (val1.penetration_distance, val1.operation,) = struct.unpack('<di',str[start:end])
        self.ord.collision_operations.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      #serialize self.ord.collision_operations
      length = len(self.ord.collision_operations)
      buff.write(struct.pack('<I', length))
      for val1 in self.ord.collision_operations:
        length = len(val1.object1)
        #serialize val1.object1
        buff.write(struct.pack('<I%ss'%length, length, val1.object1))
        length = len(val1.object2)
        #serialize val1.object2
        buff.write(struct.pack('<I%ss'%length, length, val1.object2))
        buff.write(struct.pack('<di', val1.penetration_distance, val1.operation))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.ord is None:
        self.ord = motion_planning_msgs.msg.OrderedCollisionOperations()
      end = 0
      #deserialize self.ord.collision_operations
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.ord.collision_operations = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.CollisionOperation()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.object1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.object1,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.object2
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.object2,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 12
        (val1.penetration_distance, val1.operation,) = struct.unpack('<di',str[start:end])
        self.ord.collision_operations.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

# autogenerated by genmsg_py from SetAllowedCollisionsResponse.msg. Do not edit.
import roslib.message
import struct

import planning_environment_msgs.msg

class SetAllowedCollisionsResponse(roslib.message.Message):
  _md5sum = "1f99ed5f743c8937d1578d6a9d9f8fda"
  _type = "planning_environment_msgs/SetAllowedCollisionsResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """
AllowedCollisionMatrix matrix


================================================================================
MSG: planning_environment_msgs/AllowedCollisionMatrix
# the list of link names in the matrix
string[] link_names

# the individual entries in the allowed collision matrix
# symmetric, with same order as link_names
AllowedCollisionEntry[] entries

================================================================================
MSG: planning_environment_msgs/AllowedCollisionEntry
# whether or not collision checking is enabled
bool[] enabled

"""
  __slots__ = ['matrix']
  _slot_types = ['planning_environment_msgs/AllowedCollisionMatrix']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   matrix
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(SetAllowedCollisionsResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.matrix is None:
        self.matrix = planning_environment_msgs.msg.AllowedCollisionMatrix()
    else:
      self.matrix = planning_environment_msgs.msg.AllowedCollisionMatrix()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      #serialize self.matrix.link_names
      length = len(self.matrix.link_names)
      buff.write(struct.pack('<I', length))
      for val1 in self.matrix.link_names:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.matrix.entries
      length = len(self.matrix.entries)
      buff.write(struct.pack('<I', length))
      for val1 in self.matrix.entries:
        #serialize val1.enabled
        length = len(val1.enabled)
        buff.write(struct.pack('<I', length))
        pattern = '<%sB'%length
        buff.write(struct.pack(pattern, *val1.enabled))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.matrix is None:
        self.matrix = planning_environment_msgs.msg.AllowedCollisionMatrix()
      end = 0
      #deserialize self.matrix.link_names
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.matrix.link_names = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.matrix.link_names.append(val1)
      #deserialize self.matrix.entries
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.matrix.entries = []
      for i in xrange(0, length):
        val1 = planning_environment_msgs.msg.AllowedCollisionEntry()
        #deserialize val1.enabled
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sB'%length
        start = end
        end += struct.calcsize(pattern)
        val1.enabled = struct.unpack(pattern, str[start:end])
        val1.enabled = map(bool, val1.enabled)
        self.matrix.entries.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      #serialize self.matrix.link_names
      length = len(self.matrix.link_names)
      buff.write(struct.pack('<I', length))
      for val1 in self.matrix.link_names:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.matrix.entries
      length = len(self.matrix.entries)
      buff.write(struct.pack('<I', length))
      for val1 in self.matrix.entries:
        #serialize val1.enabled
        length = len(val1.enabled)
        buff.write(struct.pack('<I', length))
        pattern = '<%sB'%length
        buff.write(val1.enabled.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.matrix is None:
        self.matrix = planning_environment_msgs.msg.AllowedCollisionMatrix()
      end = 0
      #deserialize self.matrix.link_names
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.matrix.link_names = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.matrix.link_names.append(val1)
      #deserialize self.matrix.entries
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.matrix.entries = []
      for i in xrange(0, length):
        val1 = planning_environment_msgs.msg.AllowedCollisionEntry()
        #deserialize val1.enabled
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sB'%length
        start = end
        end += struct.calcsize(pattern)
        val1.enabled = numpy.frombuffer(str[start:end], dtype=numpy.bool, count=length)
        val1.enabled = map(bool, val1.enabled)
        self.matrix.entries.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

class SetAllowedCollisions(roslib.message.ServiceDefinition):
  _type          = 'planning_environment_msgs/SetAllowedCollisions'
  _md5sum = '471f0382adb33eececdc32c89881d3a0'
  _request_class  = SetAllowedCollisionsRequest
  _response_class = SetAllowedCollisionsResponse
