/* auto-generated by gensrv_cpp from /opt/ros/boxturtle/stacks/motion_planning_environment/planning_environment_msgs/srv/GetGroupInfo.srv.  Do not edit! */
#ifndef SRV_PLANNING_ENVIRONMENT_MSGS_GETGROUPINFO_H
#define SRV_PLANNING_ENVIRONMENT_MSGS_GETGROUPINFO_H

#include <string>
#include <cstring>
#include <vector>
#include <map>
#include "ros/message.h"
#include "ros/time.h"

#include "motion_planning_msgs/ArmNavigationErrorCodes.h"

namespace planning_environment_msgs
{

struct GetGroupInfo
{

inline static std::string getDataType() { return "planning_environment_msgs/GetGroupInfo"; }
inline static std::string getMD5Sum() { return "ea5e90e42fb70a06b53bacff792b6742"; }

//! \htmlinclude Request.msg.html

class Request : public ros::Message
{
public:
  typedef boost::shared_ptr<Request> Ptr;
  typedef boost::shared_ptr<Request const> ConstPtr;

  typedef std::string _group_name_type;

  std::string group_name;

  Request() : ros::Message()
  {
  }
  Request(const Request &copy) : ros::Message(),
    group_name(copy.group_name)
  {
    (void)copy;
  }
  Request &operator =(const Request &copy)
  {
    if (this == &copy)
      return *this;
    group_name = copy.group_name;
    return *this;
  }
  virtual ~Request() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("planning_environment_msgs/GetGroupInfoRequest"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# A service call to get the joints in a particular joint group.\n"
    "# A group is a collection of joints (e.g. right_arm).\n"
    "# The set of group names is set using a planning_groups.yaml file.\n"
    "# The file defines the set of available groups and the sets of joints \n"
    "# and links available in each of them.\n"
    "string group_name\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("ea5e90e42fb70a06b53bacff792b6742"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("planning_environment_msgs/GetGroupInfo"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + group_name.length(); // group_name
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    unsigned __ros_group_name_len = group_name.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_group_name_len);
    SROS_SERIALIZE_BUFFER(write_ptr, group_name.c_str(), __ros_group_name_len);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    unsigned __ros_group_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_group_name_len);
    group_name = std::string((const char *)read_ptr, __ros_group_name_len);
    read_ptr += __ros_group_name_len;
    return read_ptr;
  }
};

typedef boost::shared_ptr<Request> RequestPtr;
typedef boost::shared_ptr<Request const> RequestConstPtr;

//! \htmlinclude Response.msg.html

class Response : public ros::Message
{
public:
  typedef boost::shared_ptr<Response> Ptr;
  typedef boost::shared_ptr<Response const> ConstPtr;

  typedef std::vector<std::string> _joint_names_type;
  typedef std::vector<std::string> _link_names_type;
  typedef motion_planning_msgs::ArmNavigationErrorCodes _error_code_type;

  std::vector<std::string> joint_names;
  std::vector<std::string> link_names;
  motion_planning_msgs::ArmNavigationErrorCodes error_code;

  Response() : ros::Message()
  {
  }
  Response(const Response &copy) : ros::Message(),
    error_code(copy.error_code)
  {
    (void)copy;
    joint_names = copy.joint_names;
    link_names = copy.link_names;
  }
  Response &operator =(const Response &copy)
  {
    if (this == &copy)
      return *this;
    joint_names.clear();
    link_names.clear();
    joint_names = copy.joint_names;
    link_names = copy.link_names;
    error_code = copy.error_code;
    return *this;
  }
  virtual ~Response() 
  {
    joint_names.clear();
    link_names.clear();
  }
  inline static std::string __s_getDataType() { return std::string("planning_environment_msgs/GetGroupInfoResponse"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "\n"
    "# A vector of joint names for all the joints in the group\n"
    "string[] joint_names\n"
    "\n"
    "# A vector of link names for all the links in the group\n"
    "string[] link_names\n"
    "\n"
    "# Integer error code corresponding to the first check that was violated.\n"
    "# The message contains both the returned error code value and a set \n"
    "# of possible error codes.\n"
    "motion_planning_msgs/ArmNavigationErrorCodes error_code\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/ArmNavigationErrorCodes\n"
    "int32 val\n"
    "\n"
    "# overall behavior\n"
    "int32 PLANNING_FAILED=-1\n"
    "int32 SUCCESS=1\n"
    "int32 TIMED_OUT=-2\n"
    "\n"
    "# start state errors\n"
    "int32 START_STATE_IN_COLLISION=-3\n"
    "int32 START_STATE_VIOLATES_PATH_CONSTRAINTS=-4\n"
    "\n"
    "# goal errors\n"
    "int32 GOAL_IN_COLLISION=-5\n"
    "int32 GOAL_VIOLATES_PATH_CONSTRAINTS=-6\n"
    "\n"
    "# robot state\n"
    "int32 INVALID_ROBOT_STATE=-7\n"
    "int32 INCOMPLETE_ROBOT_STATE=-8\n"
    "\n"
    "# planning request errors\n"
    "int32 INVALID_PLANNER_ID=-9\n"
    "int32 INVALID_NUM_PLANNING_ATTEMPTS=-10\n"
    "int32 INVALID_ALLOWED_PLANNING_TIME=-11\n"
    "int32 INVALID_GROUP_NAME=-12\n"
    "int32 INVALID_GOAL_JOINT_CONSTRAINTS=-13\n"
    "int32 INVALID_GOAL_POSITION_CONSTRAINTS=-14\n"
    "int32 INVALID_GOAL_ORIENTATION_CONSTRAINTS=-15\n"
    "int32 INVALID_PATH_JOINT_CONSTRAINTS=-16\n"
    "int32 INVALID_PATH_POSITION_CONSTRAINTS=-17\n"
    "int32 INVALID_PATH_ORIENTATION_CONSTRAINTS=-18\n"
    "\n"
    "# state/trajectory monitor errors\n"
    "int32 INVALID_TRAJECTORY=-19\n"
    "int32 INVALID_INDEX=-20\n"
    "int32 JOINT_LIMITS_VIOLATED=-21\n"
    "int32 PATH_CONSTRAINTS_VIOLATED=-22\n"
    "int32 COLLISION_CONSTRAINTS_VIOLATED=-23\n"
    "int32 GOAL_CONSTRAINTS_VIOLATED=-24\n"
    "int32 JOINTS_NOT_MOVING=-25\n"
    "int32 TRAJECTORY_CONTROLLER_FAILED=-26\n"
    "\n"
    "# system errors\n"
    "int32 FRAME_TRANSFORM_FAILURE=-27\n"
    "int32 COLLISION_CHECKING_UNAVAILABLE=-28\n"
    "int32 ROBOT_STATE_STALE=-29\n"
    "int32 SENSOR_INFO_STALE=-30\n"
    "\n"
    "# kinematics errors\n"
    "int32 NO_IK_SOLUTION=-31\n"
    "int32 INVALID_LINK_NAME=-32\n"
    "int32 IK_LINK_IN_COLLISION=-33\n"
    "int32 NO_FK_SOLUTION=-34\n"
    "int32 KINEMATICS_STATE_IN_COLLISION=-35\n"
    "\n"
    "# general errors\n"
    "int32 INVALID_TIMEOUT=-36\n"
    "\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("ea5e90e42fb70a06b53bacff792b6742"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("planning_environment_msgs/GetGroupInfo"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  void set_joint_names_size(uint32_t __ros_new_size)
  {
    this->joint_names.resize(__ros_new_size);
  }
  inline uint32_t get_joint_names_size() const { return joint_names.size(); }
  uint32_t calc_joint_names_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t joint_names_size = joint_names.size();
    for (size_t i = 0; i < joint_names_size; i++)
      l += 4 + joint_names[i].length();
    return l;
  }
  inline void get_joint_names_vec (std::vector<std::string> &__ros_vec) const
  {
    __ros_vec = this->joint_names;
  }
  inline void set_joint_names_vec(const std::vector<std::string> &__ros_vec)
  {
    this->joint_names = __ros_vec;
  }
  void set_link_names_size(uint32_t __ros_new_size)
  {
    this->link_names.resize(__ros_new_size);
  }
  inline uint32_t get_link_names_size() const { return link_names.size(); }
  uint32_t calc_link_names_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t link_names_size = link_names.size();
    for (size_t i = 0; i < link_names_size; i++)
      l += 4 + link_names[i].length();
    return l;
  }
  inline void get_link_names_vec (std::vector<std::string> &__ros_vec) const
  {
    __ros_vec = this->link_names;
  }
  inline void set_link_names_vec(const std::vector<std::string> &__ros_vec)
  {
    this->link_names = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + calc_joint_names_array_serialization_len(); // joint_names
    __l += 4 + calc_link_names_array_serialization_len(); // link_names
    __l += error_code.serializationLength(); // error_code
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    uint32_t __joint_names_size = joint_names.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __joint_names_size);
    for (size_t i = 0; i < __joint_names_size; i++)
    {
      unsigned __ros_joint_names_i__len = joint_names[i].length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_joint_names_i__len);
    SROS_SERIALIZE_BUFFER(write_ptr, joint_names[i].c_str(), __ros_joint_names_i__len);
    }
    uint32_t __link_names_size = link_names.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __link_names_size);
    for (size_t i = 0; i < __link_names_size; i++)
    {
      unsigned __ros_link_names_i__len = link_names[i].length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_link_names_i__len);
    SROS_SERIALIZE_BUFFER(write_ptr, link_names[i].c_str(), __ros_link_names_i__len);
    }
    write_ptr = error_code.serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    uint32_t __joint_names_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __joint_names_size);
    set_joint_names_size(__joint_names_size);
    for (size_t i = 0; i < __joint_names_size; i++)
    {
      unsigned __ros_joint_names_i__len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_joint_names_i__len);
    joint_names[i] = std::string((const char *)read_ptr, __ros_joint_names_i__len);
    read_ptr += __ros_joint_names_i__len;
    }
    uint32_t __link_names_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __link_names_size);
    set_link_names_size(__link_names_size);
    for (size_t i = 0; i < __link_names_size; i++)
    {
      unsigned __ros_link_names_i__len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_link_names_i__len);
    link_names[i] = std::string((const char *)read_ptr, __ros_link_names_i__len);
    read_ptr += __ros_link_names_i__len;
    }
    read_ptr = error_code.deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Response> ResponsePtr;
typedef boost::shared_ptr<Response const> ResponseConstPtr;

Request request;
Response response;

};

}

#endif
