/* auto-generated by gensrv_cpp from /opt/ros/boxturtle/stacks/motion_planning_environment/planning_environment_msgs/srv/GetRobotState.srv.  Do not edit! */
#ifndef SRV_PLANNING_ENVIRONMENT_MSGS_GETROBOTSTATE_H
#define SRV_PLANNING_ENVIRONMENT_MSGS_GETROBOTSTATE_H

#include <string>
#include <cstring>
#include <vector>
#include <map>
#include "ros/message.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "sensor_msgs/JointState.h"
#include "geometry_msgs/Point.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"
#include "motion_planning_msgs/MultiDOFJointState.h"
#include "motion_planning_msgs/RobotState.h"
#include "motion_planning_msgs/ArmNavigationErrorCodes.h"

namespace planning_environment_msgs
{

struct GetRobotState
{

inline static std::string getDataType() { return "planning_environment_msgs/GetRobotState"; }
inline static std::string getMD5Sum() { return "52f4e3fb2c5cdbea0def2cf72321f40e"; }

//! \htmlinclude Request.msg.html

class Request : public ros::Message
{
public:
  typedef boost::shared_ptr<Request> Ptr;
  typedef boost::shared_ptr<Request const> ConstPtr;



  Request() : ros::Message()
  {
  }
  Request(const Request &copy) : ros::Message()
  {
    (void)copy;
  }
  Request &operator =(const Request &copy)
  {
    if (this == &copy)
      return *this;
    return *this;
  }
  virtual ~Request() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("planning_environment_msgs/GetRobotStateRequest"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This message returns the current robot state from a node that has information\n"
    "# about the current state of the robot\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("52f4e3fb2c5cdbea0def2cf72321f40e"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("planning_environment_msgs/GetRobotState"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    return read_ptr;
  }
};

typedef boost::shared_ptr<Request> RequestPtr;
typedef boost::shared_ptr<Request const> RequestConstPtr;

//! \htmlinclude Response.msg.html

class Response : public ros::Message
{
public:
  typedef boost::shared_ptr<Response> Ptr;
  typedef boost::shared_ptr<Response const> ConstPtr;

  typedef motion_planning_msgs::RobotState _robot_state_type;
  typedef motion_planning_msgs::ArmNavigationErrorCodes _error_code_type;

  motion_planning_msgs::RobotState robot_state;
  motion_planning_msgs::ArmNavigationErrorCodes error_code;

  Response() : ros::Message()
  {
  }
  Response(const Response &copy) : ros::Message(),
    robot_state(copy.robot_state),
    error_code(copy.error_code)
  {
    (void)copy;
  }
  Response &operator =(const Response &copy)
  {
    if (this == &copy)
      return *this;
    robot_state = copy.robot_state;
    error_code = copy.error_code;
    return *this;
  }
  virtual ~Response() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("planning_environment_msgs/GetRobotStateResponse"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "\n"
    "# The returned robot_state contains the current state of the robot\n"
    "motion_planning_msgs/RobotState robot_state\n"
    "\n"
    "# Integer error code corresponding to the first check that was violated\n"
    "# The message contains both the returned error code value and a set \n"
    "# of possible error codes\n"
    "motion_planning_msgs/ArmNavigationErrorCodes error_code\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/RobotState\n"
    "# This message contains information about the robot state, i.e. the positions of its joints and links\n"
    "sensor_msgs/JointState joint_state\n"
    "motion_planning_msgs/MultiDOFJointState multi_dof_joint_state\n"
    "================================================================================\n"
    "MSG: sensor_msgs/JointState\n"
    "# This is a message that holds data to describe the state of a set of torque controlled joints. \n"
    "#\n"
    "# The state of each joint is defined by:\n"
    "#  * the position of the joint, \n"
    "#  * the velocity of the joint and \n"
    "#  * the effort that is applied in the joint.\n"
    "#\n"
    "# Each joint is uniquely identified by its name\n"
    "# The header specifies the time at which the joint states were recorded. All the joint states\n"
    "# in one message have to be recorded at the same time.\n"
    "#\n"
    "# This message consists of a multiple arrays, one for each part of the joint state. \n"
    "# The goal is to make each of the fields optional. When e.g. your joints have no\n"
    "# effort associated with them, you can leave the effort array empty. \n"
    "#\n"
    "# All arrays in this message should have the same size, or be empty.\n"
    "# This is the only way to uniquely associate the joint name with the correct\n"
    "# states.\n"
    "\n"
    "\n"
    "Header header\n"
    "\n"
    "string[] name\n"
    "float64[] position\n"
    "float64[] velocity\n"
    "float64[] effort\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/MultiDOFJointState\n"
    "#A representation of a multi-dof joint state\n"
    "time stamp\n"
    "string joint_name\n"
    "string frame_id\n"
    "string child_frame_id\n"
    "geometry_msgs/Pose pose\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/ArmNavigationErrorCodes\n"
    "int32 val\n"
    "\n"
    "# overall behavior\n"
    "int32 PLANNING_FAILED=-1\n"
    "int32 SUCCESS=1\n"
    "int32 TIMED_OUT=-2\n"
    "\n"
    "# start state errors\n"
    "int32 START_STATE_IN_COLLISION=-3\n"
    "int32 START_STATE_VIOLATES_PATH_CONSTRAINTS=-4\n"
    "\n"
    "# goal errors\n"
    "int32 GOAL_IN_COLLISION=-5\n"
    "int32 GOAL_VIOLATES_PATH_CONSTRAINTS=-6\n"
    "\n"
    "# robot state\n"
    "int32 INVALID_ROBOT_STATE=-7\n"
    "int32 INCOMPLETE_ROBOT_STATE=-8\n"
    "\n"
    "# planning request errors\n"
    "int32 INVALID_PLANNER_ID=-9\n"
    "int32 INVALID_NUM_PLANNING_ATTEMPTS=-10\n"
    "int32 INVALID_ALLOWED_PLANNING_TIME=-11\n"
    "int32 INVALID_GROUP_NAME=-12\n"
    "int32 INVALID_GOAL_JOINT_CONSTRAINTS=-13\n"
    "int32 INVALID_GOAL_POSITION_CONSTRAINTS=-14\n"
    "int32 INVALID_GOAL_ORIENTATION_CONSTRAINTS=-15\n"
    "int32 INVALID_PATH_JOINT_CONSTRAINTS=-16\n"
    "int32 INVALID_PATH_POSITION_CONSTRAINTS=-17\n"
    "int32 INVALID_PATH_ORIENTATION_CONSTRAINTS=-18\n"
    "\n"
    "# state/trajectory monitor errors\n"
    "int32 INVALID_TRAJECTORY=-19\n"
    "int32 INVALID_INDEX=-20\n"
    "int32 JOINT_LIMITS_VIOLATED=-21\n"
    "int32 PATH_CONSTRAINTS_VIOLATED=-22\n"
    "int32 COLLISION_CONSTRAINTS_VIOLATED=-23\n"
    "int32 GOAL_CONSTRAINTS_VIOLATED=-24\n"
    "int32 JOINTS_NOT_MOVING=-25\n"
    "int32 TRAJECTORY_CONTROLLER_FAILED=-26\n"
    "\n"
    "# system errors\n"
    "int32 FRAME_TRANSFORM_FAILURE=-27\n"
    "int32 COLLISION_CHECKING_UNAVAILABLE=-28\n"
    "int32 ROBOT_STATE_STALE=-29\n"
    "int32 SENSOR_INFO_STALE=-30\n"
    "\n"
    "# kinematics errors\n"
    "int32 NO_IK_SOLUTION=-31\n"
    "int32 INVALID_LINK_NAME=-32\n"
    "int32 IK_LINK_IN_COLLISION=-33\n"
    "int32 NO_FK_SOLUTION=-34\n"
    "int32 KINEMATICS_STATE_IN_COLLISION=-35\n"
    "\n"
    "# general errors\n"
    "int32 INVALID_TIMEOUT=-36\n"
    "\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("52f4e3fb2c5cdbea0def2cf72321f40e"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("planning_environment_msgs/GetRobotState"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += robot_state.serializationLength(); // robot_state
    __l += error_code.serializationLength(); // error_code
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    write_ptr = robot_state.serialize(write_ptr, seq);
    write_ptr = error_code.serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = robot_state.deserialize(read_ptr);
    read_ptr = error_code.deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Response> ResponsePtr;
typedef boost::shared_ptr<Response const> ResponseConstPtr;

Request request;
Response response;

};

}

#endif
